<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on June 5, 2009 at 11:33:25 am</time-stamp>
<!-- Changes from: PV-CMG(Green.3,carry)  to: PV-CMG(Green.4,carry) -->


<methods>
<class-id>PROVISO.PvChannelManager</class-id> <category>private</category>

<body package="PV-CMG" selector="isRunningApplication:">isRunningApplication: aPvApplicationSpec 
	"Answer true if the app is running or if we cannot tell.
	It is safer to assume it is running on an error - that way we don't start 2 instances of the same app at the same time (very bad)"

	| application answer applicationManager |
	^self dstFacade corbaOnErrorIn: 
			[application := self dstFacade 
						getObjectNamed: aPvApplicationSpec applicationManagerName
						onErrorDo: 
							[:ex | 
							self warnFailedTestIsRunningApplication: aPvApplicationSpec
								withError: 'application manager: ' 
										, aPvApplicationSpec applicationManagerName , ' unreachable because of: ' 
										, ex description.
							^true].
			answer := application isNil 
						ifTrue: 
							[self warnFailedTestIsRunningApplication: aPvApplicationSpec
								withError: 'application manager: ' 
										, aPvApplicationSpec applicationManagerName , ' unreachable'.
							true]
						ifFalse: 
							[applicationManager := application server.
							applicationManager isRunningApplication: aPvApplicationSpec].
			answer = true]
		doWithError: 
			[:error | 
			self dstFacade dumpWalkbackForException: error.
			self warnFailedTestIsRunningApplication: aPvApplicationSpec
				withError: error description.
			true]</body>
</methods>


<methods>
<class-id>PROVISO.PvApplicationManager</class-id> <category>CORBA Interface</category>

<body package="PV-CMG" selector="isRunningApplication:">isRunningApplication: aPvApplicationSpec 
	"Answer true if the app is running or we were unable to tell (assume it is running).
	We will assume an app is running if we can't tell or get an order.  This will keep us from starting 2 instances of the same app (very bad)"

	^PvBlockingTask execute: 
			[self dstFacade corbaOnErrorIn: 
					[| processId |
					processId := self processIdForApplicationSpec: aPvApplicationSpec.
					processId notNil]
				doWithError: 
					[:error | 
					self dstFacade dumpWalkbackForException: error.
					self warnFailedTestIsRunningApplication: aPvApplicationSpec
						withError: error description.
					true]]
		named: self class name</body>
</methods>



</st-source>
